<script setup lang="ts">
  import { Product, ProductReview } from '@shopware-pwa/types';

  const props = defineProps<{
    product: Product;
    totalReviews?: number;
  }>();

  const { product } = toRefs(props);
  const productId = computed(() => product.value.parentId || product.value.id);

  const { loadProductReviews, productReviews, isLoading } = useProductReviews(productId);

  const format: Intl.DateTimeFormatOptions = {
    year: 'numeric',
    month: 'short',
    day: 'numeric',
    hour: 'numeric',
    minute: 'numeric',
    hour12: true,
  };

  const formatDate = (date: string) => new Date(date).toLocaleDateString('en-us', format);

  const initial = ref<boolean>(true);
  const currentPage = ref<number>(1);
  const itemPerPage = ref<number>(10);

  const changePage = async (page: number) => {
    await loadProductReviews({
      limit: itemPerPage.value,
      page,
    });
    currentPage.value = page;
  };

  onMounted(async () => {
    await loadProductReviews();
    initial.value = false;
  });
</script>

<template>
  <div v-if="initial" class="flex animate-pulse flex-col gap-4">
    <div class="flex h-5 justify-between">
      <div class="w-1/5 rounded-md bg-gray-100" />
      <div class="w-3.5/5 rounded-md bg-gray-100" />
    </div>
    <div class="h-4 w-full rounded-sm bg-gray-100" />
    <div class="h-6 w-full rounded-sm bg-gray-100" />
    <div class="h-6 w-full rounded-md bg-gray-100" />
  </div>
  <div v-else-if="!productReviews.length">{{ $t('reviews.empty') }}</div>
  <div v-else>
    <SwLoading
      v-if="isLoading"
      class="text-primary z-loading absolute inset-0 bg-white/80 text-3xl"
    />
    <div
      v-for="review in productReviews"
      :key="review.id"
      class="border-border border-b-1 pb-3 last:border-b-0"
    >
      <div
        class="cms-block-product-description-reviews__reviews-time mt-3 break-words text-sm text-gray-600"
      >
        <span>{{ formatDate(review.createdAt) }}</span>
      </div>
      <div
        class="cms-block-product-description-reviews__reviews-rating mt-2 inline-flex items-center"
      >
        <SwRating :model-value="review.points" disabled />
        <div class="cms-block-product-description-reviews__reviews-title ml-2 font-semibold">
          <p>{{ review.title }}</p>
        </div>
      </div>
      <div class="cms-block-product-description-reviews__reviews-content mt-2">
        <span>{{ review.content }}</span>
      </div>
      <div
        v-if="review.comment"
        class="cms-block-product-description-reviews__reviews-content text-information-subdued mt-2 flex"
      >
        <span>{{ `${$t('reviews.ourFeedback')}${review.comment}` }}</span>
      </div>
    </div>
    <div class="mt-4 flex justify-center">
      <SwPagination
        :total="totalReviews"
        :current-page="currentPage"
        :page-size="itemPerPage"
        @update:model-value="changePage"
      />
    </div>
  </div>
</template>
